{% set item_image = page.media.images|first %}
{% set synthesiaData = page.header.synthesia_data|first %}
{% set tag_dict = theme_config.tag_colors %}

{% macro listGroupDetail(key, value) %}
    <div class="grid-x grid-padding-y">
        <div class="cell shrink">{{ key }}</div>
        <div class="cell auto text-right">{{ value }}</div>
    </div>
{% endmacro listGroupDetail %}

{% macro listGroupTags(tags, tag_dict) %}
    <div id="tag-section" class="card-section">
        {% for tag in tags %}
            {%- if array_key_exists(tag, tag_dict) -%}
                {% set tag_type = tag_dict[tag] %}
            {%- else -%}
                {% set tag_type = 'secondary' %}
            {%- endif -%}
            <span class="label {{ tag_type }}">{{ tag }}</span>
        {% endfor %}
    </div>
{% endmacro listGroupTags %}

{% macro listGroupDownload(page, fn, icon) %}
    <a class="clear button download" href="{{ page.media[fn].url }}">{% if icon %}<i class="{{ icon }}"></i> {% endif %}{{ fn }}</a>
{% endmacro listGroupDownload %}

{% macro cardYouTube(y_id) %}
    <div id="youtube" class="card">
        <div class="responsive-embed">
            <iframe src="https://www.youtube-nocookie.com/embed/{{ y_id }}" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>
        </div>
    </div>
{% endmacro cardYouTube %}

{% macro cardNicoVideo(n_id) %}
    <div id="nicovideo" class="card">
        <div class="responsive-embed">
            <iframe src="https://embed.nicovideo.jp/watch/{{ n_id }}" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>
        </div>
    </div>
{% endmacro cardNicoVideo %}

{% if page.header.youtube_id %}
    {{ _self.cardYouTube(page.header.youtube_id) }}
{% endif %}

{% if page.header.nicovideo_id %}
    {{ _self.cardNicoVideo(page.header.nicovideo_id) }}
{% endif %}

<div id="song-info" class="card">
    <div class="card-divider">
        <p>Song Info</p>
    </div>

    {#{% if item_image %}
        {{ item_image.html(page.title, '', 'card-img-top') }}
    {% endif %}#}

    <div class="card-section">
        {{- page.content -}}
    </div>

    {%- if synthesiaData -%}
        <div id="info-section" class="card-section">
            {% if synthesiaData.title -%}
                {{ _self.listGroupDetail('Title', synthesiaData.title) }}
            {%- endif %}
            {% if synthesiaData.subtitle -%}
                {{ _self.listGroupDetail('Subtitle', synthesiaData.subtitle) }}
            {%- endif %}
            {% if synthesiaData.composer -%}
                {{ _self.listGroupDetail('Composer', synthesiaData.composer) }}
            {%- endif %}
            {% if synthesiaData.copyright -%}
                {{ _self.listGroupDetail('Copyright', synthesiaData.copyright) }}
            {%- endif %}
            {% if synthesiaData.madeFamousby -%}
                {{ _self.listGroupDetail('Made Famous By', synthesiaData.madeFamousby) }}
            {%- endif %}
        </div>
    {%- endif -%}

</div>

<div id="sheet-info" class="card">
    <div class="card-divider">
        <p>Sheet Info</p>
    </div>

    <div id="info-section" class="card-section">
        {% if synthesiaData and synthesiaData.arranger -%}
            {{ _self.listGroupDetail('Arranger', synthesiaData.arranger) }}
        {%- endif %}

        {% if page.date -%}
            {%- set _pub_date = page.date|date('M jS Y') -%}
            {{ _self.listGroupDetail('Publish Date', _pub_date) }}
        {%- endif %}
    </div>

    {{ _self.listGroupTags(page.taxonomy.tag, tag_dict) }}
</div>

<div class="card">
    <div class="card-divider">
        <p>Download</p>
    </div>

    <div id="info-section" class="card-section stacked button-group">
        {% if page.header.midi -%}
            {{ _self.listGroupDownload(page, page.header.midi, 'fas fa-file-audio') }}
        {%- endif %}
        {% if page.header.pdf -%}
            {{ _self.listGroupDownload(page, page.header.pdf, 'fas fa-file-pdf') }}
        {%- endif %}
        {% if page.header.synthesia -%}
            {{ _self.listGroupDownload(page, page.header.synthesia, 'fas fa-file-alt') }}
        {%- endif %}
        {% if page.header.musescore -%}
            {{ _self.listGroupDownload(page, page.header.musescore, 'fas fa-file-alt') }}
        {%- endif %}
    </div>
</div>
